﻿{
  TSPIs
    Susie Plugin を使ったコンポーネント
    SPIs.pasに入っています
  TSPIBitmap
    TSPIs 対応のビットマップ TSPIBitmap
    SPIBmp.pasに入っています
  TSPINkDIB
    TSPIs 対応のTNkDIB
    SPINkDIB.pasに入っています

  ver  1.26u0
  auth 綾川鞠乃介
  date 2009/05/05
  memo Delphi 2009で動作するように調整

  ver  1.26u1
  auth 綾川鞠乃介
  date 2023/06/16
  memo .sph対応
       W系API対応
       その他細かい修正

  ------TSPIs------
  機能追加
    64bit版である.sphの対応、及びW系のAPIの対応を行いました。
    TPIsのEnabledUnicodeAPIプロパティ
      true → SPI/SPHの読み込み時にTxxSPIのEnabledUnicodeAPIをtrueでcreate
              します。ただし、TxxSPIでW系APIが有効かどうかはそれぞれSPI/SPH
              によります。もし必要なW系APIが足りない場合はTxxSPIのEnabledUnicodeAPI
              プロパティはfalseになります。逆に必要なW系APIが全て有効ならば
              TxxSPIのEnabledUnicodeAPIプロパティはtrueになります。
      false →TxxSPIは常に従来のAPIのみ有効になります。W系APIがTxxSPIで必要と
              される物全てが存在することは保証されません。

  ----------------------------------------------------------------------------
  Ver 1.26
  作者:計(kei-i@sams.co.jp)
  動作確認:Win2000+Delphi7J/6J

  ------Ver 1.25 からの変更点------
  Delphi7 への対応
  Delphi5 を動作対応外に

  ------Ver 1.24 からの変更点------
  Delphi6 への対応
  Delphi2,3,4 を動作対応外に

  ------Ver 1.23 以前との非互換------
  TSPIBitmap と TSPINkDIB から ForcedLoader プロパティと MacBinary プロパティを
  削除しました。

  ------TSPIs------
  機能
    このコンポーネントはSusie Plugin の32bit用を読込むコンポです。
    指定したディレクトリにある Plugin を根こそぎ読込めます。
    Susie.exe をインストールしてある環境では、Susie.exe と同一ディレクトリからの
    読込みもできます。

    複数生成はできません。プロジェクトの中で1つだけ使用してください。
    実行時に複数生成すると、2つめ以降の生成時に例外を起こします。

  主なプロパティ
    property  AutoSearch: Boolean;
      起動時に Plugin を読込むかどうかを指定します。
      True にすると、Loaded の中で、Search('*.spi') をします。
      デフォルトは True です。
    property  SearchOptions: TSPISearchOptions;
      Search メソッドで Plugin をどのディレクトリから探すかを指定します。
        TSPISearchOption = (spsSusieDir, spsAppDir, spsCurrentDir, spsSystemDir,
          spsWindowsDir);
        TSPISearchOptions = set of TSPISearchOption;
        spsSusieDir   ・・・Susie.exe があるディレクトリ
        spsAppDir     ・・・アプリがあるディレクトリ
        spsCurrentDir ・・・カレントディレクトリ
        spsSystemDir  ・・・Windows の System ディレクトリ
        spsWindowsDir ・・・Windows ディレクトリ
      複数指定時は、上記の順番で読込みます。
      デフォルトは [spsSusieDir, spsAppDir] です。
    property  OnSearching: TSPISearchingEvent;
      Search メソッドで Plugin 読込み前のイベントです。
        TSPISearchingEvent = procedure(Sender: TObject;
          FileName: String; var Accept: Boolean) of object;
      FileName は読み込もうとしているプラグインのフルパスのファイル名です。
      Accept を False にすると、読込みこみません。
      Accept のデフォルトは True です。
      Add, Insert メソッドではこのイベントは発生しません。
    property  OnSearch: TSPISearchEvent;
      Search メソッドで Plugin 読込んだ後のイベントです。
        TSPISearchEvent = procedure(Sender: TObject; ASPI: TSPI;
          var Accept: Boolean) of object;
      Accept を False にすると APlugin は破棄され、TSPIs では使いません。
      Accept のデフォルトは True です。
      Add, Insert メソッドではこのイベントは発生しません。
    property  OnPictureRegister: TSPIPictureRegisterEvent;
      入力用 Plugin を読込んだ後、TPicture に LoadFromFile で使う
      拡張子とクラスを登録する前に発生するイベントです。
      TSPIPictureRegisterEvent = procedure(
        Sender: TObject;
        ASPI: TInSPI;
        const AExtension, ADescription: string;
        var AGraphicClass: TGraphicClass) of object;
      AGraphicClass のデフォルトは SetDefaultGraphic メソッドで設定した
      クラスです。
      このイベントの後、AGraphicClass で指定したクラスを
      TPicture.RegisterFileFormat します。
      AGraphicClass = nil; にすると、TPicture.RegisterFileFormat しません。
    property  GraphicForcedLoader: TInSPI;
      画像の読み込み時、ここで設定したプラグインのみ経由するようになります。
      nil の時は、読み込めるプラグインを探します。
      デフォルトは nil です。
    property  MacBinary: Boolean;
      マックバイナリに対応するかどうかを指定します。
      True だと、1バイト目からの読込みに失敗した場合、129バイト目からの読込みも
      試行します。
      デフォルトは True です。
    property  GraphicPreview: Boolean;
      画像の読み込み時、可能ならプラグインのプレビュー機能を使います。
      デフォルトは False です。
    property  Plugins[Idx: Integer]: TSPI; default;
      読込み済みの Plugin を返します。
      実行時のみのプロパティです。

  主なメソッド
    procedure Add(ASPI: TSPI);
    procedure Insert(Idx: Integer; ASPI: TSPI);
    procedure Delete(Idx: Integer);
    procedure Remove(ASPI: TSPI);
    function  IndexOf(ASPI: TSPI): Integer;
    procedure Exchange(Idx1, Idx2: Integer);
    procedure Clear;
    function  Count: Integer;
      TList、TStringList の同名のメソッドと同様の意味です(手抜き^^;;)
    function  IndexOfSPIName(ASPIName: String): Integer;
      読込み済みのプラグインの中から、ASPIName がファイル名のプラグイン
      の位置(インデックス)を返します。ASPIName はフルパスにしてください。
      見つからなければ、-1 を返します。
    procedure Search(AWildCard: TFileName);
      Plugin を探して読込みます。
      AWildCard はワイルドカードが書けます。
      ディレクトリを指定しない場合、SerachOptions に従います。
    class procedure SetDefaultGraphic(Value: TGraphicClass);
    class function  GetDefaultGraphic: TGraphicClass;
      TPicture に登録するクラスを設定／取得します。
      Plugin を読込んだ後、OnPictureRegister イベントで変更がなければ、
      ここで設定されているクラスを
        TPicture.RegisterFileFormat
      します。

  ------TSPIBitmap------
  機能
    TSPIs と連携して、Susie Plugin 経由で画像を読込みます。
    TBitmap から継承していて、読込み以外の機能は全て TBitmap と同じです。

  主なプロパティ
    property  OnProgress: TProgressEvent;
      Delphi 3 以上のみ。
      画像データの読込み中に発生します。
      Bitmap 形式データ読込み時には発生しません。

  主なメソッド
    procedure LoadFromFile(const Filename: string); override;
    procedure LoadFromStream(Stream: TStream); override;
      TBitmap の同名のメソッドと同じです。
      違いは、BMP 形式以外に、Susie Plugin 対応の画像形式も読めることです。
      読込めないと、例外を起こします。
    procedure LoadFromStreamWithName(Stream: TStream;
      const FileName: String); virtual;
      FileName でファイル名を指定して、Stream から読込みます。
      Stream からの読込み方は LoadFromStream と同じですが、Susie Plugin 経由で
      読込む場合は、ファイル名をプラグインに渡します。
      読込み可能がどうかをファイル名から判別するプラグインを使ってストリームから
      読む場合は、LoadFromStream の代わりにこちらを使ってください。

  ------TSPINkDIB------
  機能
    TSPIs と連携して、Susie Plugin 経由で画像を読込みます。
    中村氏作の TNkDIB から継承していて、読込み以外の機能は全て TNkDIB
    と同じです。
    TNkDIB の持つ、24bit画像から256色パレット作成機能を使い、24bit画像を
    256色環境でも奇麗に表示することができます。
    TNkDIB は中村氏のページ(http://www.asahi-net.or.jp/~HA3T-NKMR/)などに
    あります。

  主なプロパティ
    property  PaletteOption:  TSPINkDIBPaletteOption;
      Delphi 3 以上のみ。
      24bit画像でパレットを自動作成するかどうか。
        TSPINkDIBPaletteOption = (sdpNone, sdpDev8bit, sdpAllways);
        sdpNone     ・・・作らない。
        sdpDev8bit  ・・・256色以下の環境なら作る。
        sdpAllways  ・・・作る。
      デフォルトは sdpDev8bit です。
    property  OnProgress: TProgressEvent;
      Delphi 3 以上のみ。
      画像データの読込み中に発生します。
      Bitmap 形式データ読込み時には発生しません。

  主なメソッド
    procedure LoadFromFile(const Filename: string); override;
    procedure LoadFromStream(Stream: TStream); override;
      TNkDIB の同名のメソッドと同じです。
      違いは、BMP 形式以外に、Susie Plugin 対応の画像形式も読めることです。
      読込めないと、例外を起こします。
    procedure LoadFromStreamWithName(Stream: TStream;
      const FileName: String); virtual;
      FileName でファイル名を指定して、Stream から読込みます。
      Stream からの読込み方は LoadFromStream と同じですが、Susie Plugin 経由で
      読込む場合は、ファイル名をプラグインに渡します。
      読込み可能がどうかをファイル名から判別するプラグインを使ってストリームから
      読む場合は、LoadFromStream の代わりにこちらを使ってください。

  ------TSPI, TInSPI, TXnSPI, TAmSPI------
  機能
    Susie Plugin のラッパークラス。
    TInSPI, TXnSPI, TAmSPI は TSPI から継承しています。
      TSPI  ・・・全 Plugin 共通の関数をラップします。
      TInSPI・・・入力タイプの Plugin をラップします。
      TXnSPI・・・出力タイプの Plugin をラップします。
      TAmSPI・・・展開タイプの Plugin をラップします。
    現バージョンでは、TXnSPI に意味のある実装はありません。

  ------その他------
  function  CreateSPI(AFileName: TFileName): TSPI;
    AFileName がファイル名の Susie Plugin をラップした TSPI かその継承クラスを
    生成して返します。
    Plugin のタイプ(入力か出力か展開か)に応じて、TInSPI、TXnSPI、TAmSPI の
    いずれかを生成します。未知のタイプだと、TSPI を生成します。
    Plugin の読込みに失敗すると、何も生成しないで、nil を返します。
  function  SusiePlugins: TSPIs;
    TSPIs コンポが生成されていれば、その TSPIs コンポを返します。
    生成されていなければ、nil を返します。
}

{$include SPIs.inc}

unit SPIs;

interface

uses
  winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  System.Classes,
  Vcl.Graphics;

const
  MacBinaryOffset = 128;
  MacBinaryOffsets: array[Boolean] of Integer = (0, MacBinaryOffset);

type
  PPictureInfo  = ^TPictureInfo;
  TPictureInfo = packed record
    Left:   LongInt;
    Top:    LongInt;
    Width:    LongInt;
    Height:   LongInt;
    XDensity: WORD;
    YDensity: WORD;
    ColorDepth: SmallInt;
{$IFDEF WIN64}
    dummy:    WORD;
{$ENDIF}
    HInfo:    THandle;
  end;

  PFileInfo = ^TFileInfo;
  TFileInfo = packed record
    Method: array[0..7] of AnsiChar;
    Position: ULONG_PTR;
    CompSize: ULONG_PTR;
    FileSize: ULONG_PTR;
    TimeStamp: ULONG_PTR;
    Path: array[0..199] of AnsiChar;
    FileName: array[0..199] of AnsiChar;
    CRC: LongInt;
{$IFDEF WIN64}
    dummy: DWORD;
{$ENDIF}
  end;
  PFileInfoArray = ^TFileInfoArray;
  TFileInfoArray = array[0..MaxInt div SizeOf(TFileInfo)-1] of TFileInfo;

  PFileInfoW = ^TFileInfo;
  TFileInfoW = record
    Method: array[0..7] of AnsiChar;
    Position: ULONG_PTR;
    CompSize: ULONG_PTR;
    FileSize: ULONG_PTR;
    TimeStamp: ULONG_PTR;
    Path: array[0..199] of WideChar;
    FileName: array[0..199] of WideChar;
    CRC: LongInt;
  end;
  PFileInfoWArray = ^TFileInfoWArray;
  TFileInfoWArray = array[0..MaxInt div Sizeof(TFileInfoW)-1] of TFIleInfoW;

  {*
     susie pluginの関数はANSI baseなのでPAnsiCharで宣言
   *}
  TProgressCallback = function(Num, Done:integer; Data: LONG_PTR): Integer; stdcall;

  TGetPluginInfo = function(InfoNo: Integer;
    Buf: PAnsiChar; BufLen: Integer): Integer; stdcall;

  TConfigurationDlg = function(Parent: HWND; Fnc: Integer):
    Integer; stdcall;

  TGetPictureInfo = function(Buf: PAnsiChar; Len: LONG_PTR;
    Flag: Integer; var Info: TPictureInfo): Integer; stdcall;

  TIsSupported = function(FileName: PAnsiChar; DW: pointer): Integer; stdcall;

  TGetPicture = function(Buf: PAnsiChar; Len: LONG_PTR; Flag: Integer;
    var HBMInfo: THandle; var HBM: THandle;
    ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer; stdcall;

  TGetPreview = function(Buf: PAnsiChar; Len: LONG_PTR; Flag: Integer;
    var HBMInfo: THandle; var HBM: THandle;
    ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer; stdcall;

  TGetArchiveInfo = function(Buf: PAnsiChar; Len: LONG_PTR; Flag: DWORD;
    var FileInfoHandle: THandle): Integer; stdcall;

  TGetFileInfo = function(Buf: PAnsiChar; Len: LONG_PTR; FileName: PAnsiChar;
    Flag: DWORD;  var FileInfo: TFileInfo): Integer; stdcall;

  TGetFile = function(Src: PAnsiChar; Len: LONG_PTR; Dest: PAnsiChar; Flag: DWORD;
    ProgressCallback: TProgressCallback; Data: LONG_PTR): Integer; stdcall;

  //
  // W系API
  //
  TGetPluginInfoW = function(InfoNo: Integer;
    Buf: PWideChar; BufLen: Integer): Integer; stdcall;

  TGetPictureInfoW = function(Buf: PWideChar; Len: LONG_PTR;
    Flag: Integer; var Info: TPictureInfo): Integer; stdcall;

  TIsSupportedW = function(FileName: PWideChar; DW: pointer): Integer; stdcall;

  TGetPictureW = function(Buf: PWideChar; Len: LONG_PTR; Flag: Integer;
    var HBMInfo: THandle; var HBM: THandle;
    ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer; stdcall;

  TGetPreviewW = function(Buf: PWideChar; Len: LONG_PTR; Flag: Integer;
    var HBMInfo: THandle; var HBM: THandle;
    ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer; stdcall;

  TGetArchiveInfoW = function(Buf: PWideChar; Len: LONG_PTR; Flag: DWORD;
    var FileInfoHandle: THandle): Integer; stdcall;

  TGetFileInfoW = function(Buf: PWideChar; Len: LONG_PTR; FileName: PWideChar;
    Flag: DWORD;  var FileInfoW: TFileInfoW): Integer; stdcall;

  TGetFileW = function(Src: PWideChar; Len: LONG_PTR; Dest: PWideChar; Flag: DWORD;
    ProgressCallback: TProgressCallback; Data: LONG_PTR): Integer; stdcall;



  //  プラグインのラッパー
  TSPI = class(TObject)
  private
    FDllHandle: THandle;
    FFileName:  TFileName;
    FVersion:   AnsiString;
    FInfomation:AnsiString;
    FExtNames:  TStringList;
    FFileTypes: TStringList;
    FEnabled: Boolean;

    FEnabledUnicodeAPI:boolean;
    FVersionW:   String;
    FInfomationW:String;
    FExtNamesW:  TStringList;
    FFileTypesW: TStringList;


    FGetPluginInfo: TGetPluginInfo;
    FIsSupported:TIsSupported;
    FGetPictureInfo:TGetPictureInfo;
    FGetPicture:TGetPicture;
    FGetPreview:TGetPreview;
    FGetArchiveInfo: TGetArchiveInfo;
    FGetFileInfo: TGetFileInfo;
    FGetFile: TGetFile;
    FConfigurationDlg: TConfigurationDlg;

    FGetPluginInfoW: TGetPluginInfoW;
    FIsSupportedW:TIsSupportedW;
    FGetPictureInfoW:TGetPictureInfoW;
    FGetPictureW:TGetPictureW;
    FGetPreviewW:TGetPreviewW;
    FGetArchiveInfoW: TGetArchiveInfoW;
    FGetFileInfoW: TGetFileInfoW;
    FGetFileW: TGetFileW;

    procedure AssignAPIAddress(var P; AAPIName: String);
    procedure AssignAPIAddressW(var P; AAPIName: String);

    function  GetExtNames: TStrings;
    function  GetFileTypes: TStrings;

    function  GetExtNamesW: TStrings;
    function  GetFileTypesW: TStrings;

  protected
    procedure CheckAPIs; virtual;
    function  CheckAPIWs:boolean; virtual;
    function  DefaultEnabled: Boolean; virtual;
    procedure CheckAPI(var P; AAPIName: String);
    function  CheckAPIW(var P):boolean;
    procedure SetEnabledUnicodeAPI(AEnabledUnicodeAPI:boolean);
  public
    constructor Create(AFileName: TFileName; AEnabledUnicodeAPI:boolean); virtual;
    destructor Destroy; override;

    function  ProcAddress(AProcName: String): Pointer;
    function  ProcAddressW(AProcName: String): Pointer;

    function  GetPluginInfo(InfoNo: Integer; Buf: PAnsiChar; BufLen: Integer):
      Integer;
    function  GetPluginInfoW(InfoNo: Integer; Buf: PWideChar; BufLen: Integer):
      Integer;
    function  ConfigurationDlg(Parent: HWND; Fnc: Integer): Integer;

    property  DllHandle: THandle read FDllHandle;
    property  FileName: TFileName read FFileName;
    property  Version: AnsiString read FVersion;
    property  Infomation: AnsiString read FInfomation;
    property  ExtNames: TStrings read GetExtNames;
    property  FileTypes: TStrings read GetFileTypes;
    property  Enabled: Boolean read FEnabled write FEnabled;

    property  EnabledUnicodeAPI: Boolean read FEnabledUnicodeAPI write SetEnabledUnicodeAPI;
    property  VersionW: String read FVersionW;
    property  InfomationW: String read FInfomationW;
    property  ExtNamesW: TStrings read GetExtNamesW;
    property  FileTypesW: TStrings read GetFileTypesW;
  end;


  TLoaderSPI = class(TSPI)
  private
  protected
    procedure CheckAPIs; override;
    function  CheckAPIWs:boolean; override;
  public
    function  IsSupported(FileName: PAnsiChar; DW: pointer): Integer;

    function  IsSupportedW(FileName: PWideChar; DW: pointer): Integer;
  end;


  TInSPI = class(TLoaderSPI)
  private
  protected
    procedure CheckAPIs; override;
    function  CheckAPIWs:boolean; override;
    function  DefaultEnabled: Boolean; override;
  public
    function  GetPictureInfo(Buf: PAnsiChar; Len: LONG_PTR; Flag: Integer;
      var Info: TPictureInfo):  Integer;
    function  GetPicture(Buf: PAnsiChar; Len: LONG_PTR; Flag: Integer;
      var HBMInfo: THandle; var HBM: THandle;
      ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer;
    function  GetPreview(Buf: PAnsiChar; Len: LONG_PTR; Flag: Integer;
      var HBMInfo: THandle; var HBM: THandle;
      ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer;

    function  GetPictureInfoW(Buf: PWideChar; Len: LONG_PTR; Flag: Integer;
      var Info: TPictureInfo):  Integer;
    function  GetPictureW(Buf: PWideChar; Len: LONG_PTR; Flag: Integer;
      var HBMInfo: THandle; var HBM: THandle;
      ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer;
    function  GetPreviewW(Buf: PWideChar; Len: LONG_PTR; Flag: Integer;
      var HBMInfo: THandle; var HBM: THandle;
      ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer;
  end;


  TAmSPI = class(TLoaderSPI)
  private
  protected
    procedure CheckAPIs; override;
    function  CheckAPIWs:boolean; override;
    function  DefaultEnabled: Boolean; override;
  public
    function  GetArchiveInfo(Buf: PAnsiChar; Len: LONG_PTR; Flag: DWORD;
      var FileInfoHandle: THandle): Integer;
    function  GetFileInfo(Buf: PAnsiChar; Len: LONG_PTR; FileName: PAnsiChar;
      Flag: DWord;  var FileInfo: TFileInfo): Integer;
    function  GetFile(Src: PAnsiChar; Len: LONG_PTR; Dest: PAnsiChar; Flag: DWord;
      ProgressCallback: TProgressCallback; Data: LONG_PTR): Integer;

    function  GetArchiveInfoW(Buf: PWideChar; Len: LONG_PTR; Flag: DWORD;
      var FileInfoHandle: THandle): Integer;
    function  GetFileInfoW(Buf: PWideChar; Len: LONG_PTR; FileName: PWideChar;
      Flag: DWord;  var FileInfoW: TFileInfoW): Integer;
    function  GetFileW(Src: PWideChar; Len: LONG_PTR; Dest: PWideChar; Flag: DWord;
      ProgressCallback: TProgressCallback; Data: LONG_PTR): Integer;
  end;


  TXnSPI = class(TSPI)
  private
  protected
  public
  end;

  TSPIClass = class of TSPI;
  TLoaderSPIClass = class of TLoaderSPI;

  TSPISearchOption = (spsSusieDir, spsAppDir, spsCurrentDir, spsSystemDir,
    spsWindowsDir);
  TSPISearchOptions = set of TSPISearchOption;

  TSPISearchEvent = procedure(Sender: TObject; ASPI: TSPI;
    var Accept: Boolean) of object;
  TSPISearchingEvent = procedure(Sender: TObject; FileName: String;
    var Accept: Boolean) of object;
  TSPIPictureRegisterEvent = procedure(
    Sender: TObject;
    ASPI: TInSPI;
    const AExtension, ADescription: String;
    var AGraphicClass: TGraphicClass) of object;
  TSPILoadFromStreamWithNameEvent = procedure(Stream: TStream;
    const FileName: String) of object;


  TSPIs = class(TComponent)
  private
    FPlugins: TList;
    FSearchOptions: TSPISearchOptions;
    FOnSearch: TSPISearchEvent;
    FOnSearching: TSPISearchingEvent;
    FOnPictureRegister: TSPIPictureRegisterEvent;
    FAutoSearch: Boolean;
    FMacBinary: Boolean;
    FPreview: Boolean;
    FEnabledUnicodeAPI : boolean;
    FGraphicForcedLoader: TInSPI;

    function  GetPlugins(Idx: Integer): TSPI;
  protected
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

    procedure Loaded; override;

    procedure Add(ASPI: TSPI);
    procedure Insert(Idx: Integer; ASPI: TSPI);
    procedure Delete(Idx: Integer);
    procedure Remove(ASPI: TSPI);
    function  IndexOf(ASPI: TSPI): Integer;
    function  IndexOfSPIName(ASPIName: String): Integer;
    procedure Exchange(Idx1, Idx2: Integer);
    procedure Clear;
    function  Count: Integer;

    procedure FindPluginList(
      AClasses: array of TSPIClass;
      APriorityExt: String;
      AList: TList);

    procedure Search(AWildCard: TFileName);

    property  Plugins[Idx: Integer]: TSPI read GetPlugins; default;
    property  GraphicForcedLoader: TInSPI read FGraphicForcedLoader write FGraphicForcedLoader;
    class procedure SetDefaultGraphic(Value: TGraphicClass);
    class function  GetDefaultGraphic: TGraphicClass;
  published
    property  MacBinary: Boolean read FMacBinary write FMacBinary default True;

    property  GraphicPreview: Boolean read FPreview write FPreview;

    property  AutoSearch: Boolean read FAutoSearch write FAutoSearch
      default True;

    property  EnabledUnicodeAPI: boolean read FEnabledUnicodeAPI write FEnabledUnicodeAPI;

    property  SearchOptions: TSPISearchOptions
      read FSearchOptions write FSearchOptions;

    property  OnSearch: TSPISearchEvent read FOnSearch write FOnSearch;
    property  OnSearching: TSPISearchingEvent
      read FOnSearching write FOnSearching;
    property  OnPictureRegister: TSPIPictureRegisterEvent
      read FOnPictureRegister write FOnPictureRegister;
  end;

  ESPIInvalidSPI = class(Exception);
  ESPIInvalidAPI = class(Exception);
  ESPIFOpenErrorSPI = class(Exception);
  ESPIDupCreateSPIs = class(Exception);

function  CreateSPI(AFileName: TFileName; AEnabledUnicodeAPI:boolean): TSPI;
function  SusiePlugins: TSPIs;
{
procedure GraphicLoadFromStreamWithName(AGraphic: TGraphic; Stream: TStream;
  FileName: String);
}

procedure Register;

implementation

uses
  SPIBmp, Registry{, TypInfo};

{
type
  TMethodParam = class
  private
    FTypeName: String;
    FName: String;
    FFlags: TParamFlags;
  protected
  public
    property  Flags: TParamFlags read FFlags;
    property  Name: String read FName;
    property  TypeName: String read FTypeName;
  end;

  TMethodTypeData = class
  private
    FParams: TList;
    FKind: TMethodKind;
    FReturnTypeName: String;
    function GetParams(Idx: Integer): TMethodParam;
    function GetParamCount: Integer;
  protected
  public
    constructor Create(const ATypeData: TTypeData);
    destructor Destroy; override;

    property  Kind: TMethodKind read FKind;
    property  ReturnTypeName: String read FReturnTypeName;
    property  ParamCount: Integer read GetParamCount;
    property  Params[Idx: Integer]: TMethodParam read GetParams;
  end;
}

const
  SFOpenErrorSPI = '%s:Susie Pluginがロードできませんでした';
  SInvalidSPI = '%s:認識できないSusie Pluginです';
  SInvalidAPI = '%sは[%s]では使えないSusie Plugin APIです';
  SDupCreateSPIs = 'TSPIs は複数生成できません';

  SGetPluginInfo = 'GetPluginInfo';
  SGetPictureInfo = 'GetPictureInfo';
  SIsSupported = 'IsSupported';
  SGetPicture = 'GetPicture';
  SGetPreview = 'GetPreview';
  SConfigurationDlg = 'ConfigurationDlg';
  SGetArchiveInfo = 'GetArchiveInfo';
  SGetFileInfo = 'GetFileInfo';
  SGetFile = 'GetFile';

  SGetPluginInfoW = 'GetPluginInfoW';
  SGetPictureInfoW = 'GetPictureInfoW';
  SIsSupportedW = 'IsSupportedW';
  SGetPictureW = 'GetPictureW';
  SGetPreviewW = 'GetPreviewW';
  SGetArchiveInfoW = 'GetArchiveInfoW';
  SGetFileInfoW = 'GetFileInfoW';
  SGetFileW = 'GetFileW';

  SSPIRegKey = '\Software\Takechin\Susie\Plug-in';
  SSPIRegPath = 'Path';

  SSPIRegKey2 = '\Software\Takechin\Susie2\Plugin';
  SSPIRegPath2 = 'Folder';

var
  FDefaultGraphic: TGraphicClass = nil;
  FSusiePlugins: TSPIs = nil;

function  SusiePlugins: TSPIs;
begin
  Result := FSusiePlugins;
end;

function  CreateSPI(AFileName: TFileName; AEnabledUnicodeAPI:boolean): TSPI;
var
  spi: TSPI;
  spiClass: TSPIClass;
begin
  Result := nil;
  try
    spiClass := TSPI;
    spi := TSPI.Create(AFileName,AEnabledUnicodeAPI);
    try
      if spi.Version = '00IN' then begin
        spiClass := TInSPI;
      end
      else if spi.Version = '00AM' then begin
        spiClass := TAmSPI;
      end
      else if spi.Version = '00XN' then begin
        spiClass := TXnSPI;
      end;
      Result := spiClass.Create(AFileName,AEnabledUnicodeAPI);
    finally
      spi.Free;
    end;
  except
    //  プラグインが読込めなかったり、必要な関数が export されていない
    //  場合、単に読込まないだけ。
    on ESPIInvalidSPI do begin
    end;
    on ESPIFOpenErrorSPI do begin
    end;
  end;
end;

{------TSPI------}
constructor TSPI.Create(AFileName: TFileName; AEnabledUnicodeAPI:boolean);
var
  buf: array[0..255] of Char;
  ansibuf, extName, fileType: array[0..255] of AnsiChar;
  wbuf,extNameW,fileTypeW : array[0..255] of WideChar;
  infoIdx: Integer;
begin
  inherited Create;

  FEnabledUnicodeAPI:=false;

  FDllHandle := LoadLibrary(PChar(AFileName));
  if FDllHandle = 0 then begin
    raise ESPIFOpenErrorSPI.CreateFmt(SFOpenErrorSPI, [AFileName]);
  end;

  fillchar(buf,sizeof(buf),0);
  if GetModuleFileName(FDllHandle, buf, SizeOf(buf)-1) > 0 then begin
    FFileName := buf;
  end
  else begin
    FFileName := AFileName;
  end;

  AssignAPIAddress(FGetPluginInfo, SGetPluginInfo);
  AssignAPIAddress(FConfigurationDlg, SConfigurationDlg);
  AssignAPIAddress(FIsSupported, SIsSupported);
  AssignAPIAddress(FGetPictureInfo, SGetPictureInfo);
  AssignAPIAddress(FGetPicture, SGetPicture);
  AssignAPIAddress(FGetPreview, SGetPreview);
  AssignAPIAddress(FGetArchiveInfo, SGetArchiveInfo );
  AssignAPIAddress(FGetFileInfo, SGetFileInfo);
  AssignAPIAddress(FGetFile, SGetFile);

  AssignAPIAddressW(FGetPluginInfoW, SGetPluginInfoW);
  AssignAPIAddressW(FIsSupportedW, SIsSupportedW);
  AssignAPIAddressW(FGetPictureInfoW, SGetPictureInfoW);
  AssignAPIAddressW(FGetPictureW, SGetPictureW);
  AssignAPIAddressW(FGetPreviewW, SGetPreviewW);
  AssignAPIAddressW(FGetArchiveInfoW, SGetArchiveInfoW );
  AssignAPIAddressW(FGetFileInfoW, SGetFileInfoW);
  AssignAPIAddressW(FGetFileW, SGetFileW);

  CheckAPIs;

  EnabledUnicodeAPI:=AEnabledUnicodeAPI;

  if GetPluginInfo(0, ansibuf, SizeOf(ansibuf)-1) > 0 then begin
    FVersion := ansibuf;
  end;

  if GetPluginInfo(1, ansibuf, SizeOf(ansibuf)-1) > 0 then begin
    FInfomation := ansibuf;
  end;

  FExtNames := TStringList.Create;
  FFileTypes:= TStringList.Create;
  infoIdx := 2;
  while True do begin
    if (GetPluginInfo(infoIdx, extName, SizeOf(extName)-1) > 0) and
      (GetPluginInfo(infoIdx+1, fileType, SizeOf(fileType)-1) > 0) then begin
      FExtNames.Add(string(extName));
      FFileTypes.Add(string(fileType));
    end
    else begin
      Break;
    end;
    Inc(infoIdx, 2);
  end;

  if EnabledUnicodeAPI then begin
    if GetPluginInfoW(0, wbuf, SizeOf(wbuf)-1) > 0 then begin
      FVersionW := wbuf;
    end;

    if GetPluginInfoW(1, wbuf, SizeOf(wbuf)-1) > 0 then begin
      FInfomationW := wbuf;
    end;

    FExtNamesW := TStringList.Create;
    FFileTypesW:= TStringList.Create;
    infoIdx := 2;
    while True do begin
      if (GetPluginInfoW(infoIdx, extNameW, SizeOf(extNameW)-1) > 0) and
        (GetPluginInfoW(infoIdx+1, fileTypeW, SizeOf(fileTypeW)-1) > 0) then begin
        FExtNamesW.Add(string(extNameW));
        FFileTypesW.Add(string(fileTypeW));
      end
      else begin
        Break;
      end;
      Inc(infoIdx, 2);
    end;
  end;

  FEnabled := DefaultEnabled;
end;


destructor TSPI.Destroy;
begin
  FExtNames.Free;
  FFileTypes.Free;
  FExtNamesW.Free;
  FFileTypesW.Free;

  if FDLLHandle <> 0 then begin
    FreeLibrary(FDllHandle);
  end;

  inherited Destroy;
end;



function  TSPI.DefaultEnabled: Boolean;
begin
  Result := False;
end;


function  TSPI.ProcAddress(AProcName: String): Pointer;
begin
  Result := GetProcAddress(FDllHandle, PChar(AProcName));
end;

function  TSPI.ProcAddressW(AProcName: String): Pointer;
begin
  Result := GetProcAddress(FDllHandle, PWideChar(AProcName));
end;


function  TSPI.GetExtNames: TStrings;
begin
  Result := FExtNames;
end;

function  TSPI.GetExtNamesW: TStrings;
begin
  if EnabledUnicodeAPI then
    Result := FExtNamesW
  else
    result := FExtNames;
end;


function  TSPI.GetFileTypes: TStrings;
begin
  Result := FFileTypes;
end;

function  TSPI.GetFileTypesW: TStrings;
begin
  if EnabledUnicodeAPI then
    Result := FFileTypesW
  else
    Result := FFileTypes;
end;


procedure TSPI.AssignAPIAddress(var P; AAPIName: String);
begin
  Pointer(P) := ProcAddress(AAPIName);
end;

procedure TSPI.AssignAPIAddressW(var P; AAPIName: String);
begin
  Pointer(P) := ProcAddressW(AAPIName);
end;


procedure TSPI.CheckAPI(var P; AAPIName: String);
begin
  if Pointer(P) = nil then begin
    raise ESPIInvalidAPI.CreateFmt(SInvalidAPI, [AAPIName, FileName]);
  end;
end;


function TSPI.CheckAPIW(var P):boolean;
begin
  result:= Pointer(P)<>nil;
end;

procedure TSPI.CheckAPIs;
begin
  CheckAPI(FGetPluginInfo, SGetPluginInfo);
end;


function TSPI.CheckAPIWs:boolean;
begin
  result:= CheckAPIW(FGetPluginInfoW);
end;

procedure TSPI.SetEnabledUnicodeAPI(AEnabledUnicodeAPI:boolean);
begin
  FEnabledUnicodeAPI:=AEnabledUnicodeAPI and CheckAPIWs;
end;


function  TSPI.GetPluginInfo(InfoNo: Integer; Buf: PAnsiChar; BufLen: Integer):
  Integer;
begin
  CheckAPI(FGetPluginInfo, SGetPluginInfo);

  Result := FGetPluginInfo(InfoNo, Buf, BufLen);
end;

function  TSPI.GetPluginInfoW(InfoNo: Integer; Buf: PWideChar; BufLen: Integer):
  Integer;
begin
  CheckAPI(FGetPluginInfoW, SGetPluginInfoW);

  Result := FGetPluginInfoW(InfoNo, Buf, BufLen);
end;


function  TSPI.ConfigurationDlg(Parent: HWND; Fnc: Integer): Integer;
begin
  CheckAPI(FConfigurationDlg, SConfigurationDlg);

  Result := FConfigurationDlg(Parent, Fnc);
end;


{------TLoaderSPI------}
procedure TLoaderSPI.CheckAPIs;
begin
  inherited CheckAPIs;

  CheckAPI(FIsSupported, SIsSupported);
end;

function TLoaderSPI.CheckAPIWs:boolean;
begin
  result:=(inherited CheckAPIWs) and CheckAPIW(FIsSupportedW);
end;

function  TLoaderSPI.IsSupported(FileName: PAnsiChar; DW: pointer): Integer;
begin
  CheckAPI(FIsSupported, SIsSupported);

  Result := FIsSupported(FileName, DW);
end;

function  TLoaderSPI.IsSupportedW(FileName: PWideChar; DW: pointer): Integer;
begin
  CheckAPI(FIsSupportedW, SIsSupportedW);

  Result := FIsSupportedW(FileName, DW);
end;

{------TInSPI------}
function  TInSPI.DefaultEnabled: Boolean;
begin
  Result := True;
end;



procedure TInSPI.CheckAPIs;
begin
  inherited CheckAPIs;

  CheckAPI(FGetPictureInfo, SGetPictureInfo);
  CheckAPI(FGetPicture, SGetPicture);
end;

function TInSPI.CheckAPIWs:boolean;
begin
  result:=(inherited CheckAPIWs) and
          CheckAPIW(FGetPictureInfoW) and
          CheckAPIW(FGetPictureW);
end;


function  TInSPI.GetPictureInfo(Buf: PAnsiChar; Len: LONG_PTR; Flag: Integer;
  var Info: TPictureInfo):  Integer;
begin
  CheckAPI(FGetPictureInfo, SGetPictureInfo);

  Result := FGetPictureInfo(Buf, Len, Flag, Info);
end;


function  TInSPI.GetPicture(Buf: PAnsiChar; Len: LONG_PTR; Flag: Integer;
  var HBMInfo: THandle; var HBM: THandle;
  ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer;
begin
  CheckAPI(FGetPicture, SGetPicture);

  Result := FGetPicture(Buf, Len, Flag, HBMInfo, HBM, ProgressCallBack, Data);
end;


function  TInSPI.GetPreview(Buf: PAnsiChar; Len: LONG_PTR; Flag: Integer;
  var HBMInfo: THandle; var HBM: THandle;
  ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer;
begin
  CheckAPI(FGetPreview, SGetPreview);

  Result := FGetPreview(Buf, Len, Flag, HBMInfo, HBM, ProgressCallBack, Data);
end;


function  TInSPI.GetPictureInfoW(Buf: PWideChar; Len: LONG_PTR; Flag: Integer;
  var Info: TPictureInfo):  Integer;
begin
  CheckAPI(FGetPictureInfoW, SGetPictureInfoW);

  Result := FGetPictureInfoW(Buf, Len, Flag, Info);
end;


function  TInSPI.GetPictureW(Buf: PWideChar; Len: LONG_PTR; Flag: Integer;
  var HBMInfo: THandle; var HBM: THandle;
  ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer;
begin
  CheckAPI(FGetPictureW, SGetPictureW);

  Result := FGetPictureW(Buf, Len, Flag, HBMInfo, HBM, ProgressCallBack, Data);
end;


function  TInSPI.GetPreviewW(Buf: PWideChar; Len: LONG_PTR; Flag: Integer;
  var HBMInfo: THandle; var HBM: THandle;
  ProgressCallBack: TProgressCallBack; Data: LONG_PTR): Integer;
begin
  CheckAPI(FGetPreviewW, SGetPreviewW);

  Result := FGetPreviewW(Buf, Len, Flag, HBMInfo, HBM, ProgressCallBack, Data);
end;

{------TAmSPI------}
procedure TAmSPI.CheckAPIs;
begin
  inherited CheckAPIs;

  CheckAPI(FGetArchiveInfo, SGetArchiveInfo);
  CheckAPI(FGetFileInfo, SGetFileInfo);
  CheckAPI(FGetFile, SGetFile);
end;


function TAmSPI.CheckAPIWs:boolean;
begin
  result:=(inherited CheckAPIWs) and
          CheckAPIW(FGetArchiveInfoW) and
          CheckAPIW(FGetFileInfoW) and
          CheckAPIW(FGetFileW);
end;

function  TAmSPI.DefaultEnabled: Boolean;
begin
  Result := True;
end;




function  TAmSPI.GetArchiveInfo(Buf: PAnsiChar; Len: LONG_PTR; Flag: DWord;
  var FileInfoHandle: THandle): Integer;
begin
  CheckAPI(FGetArchiveInfo, SGetArchiveInfo);

  Result := FGetArchiveInfo(Buf, Len, Flag, FileInfoHandle);
end;


function  TAmSPI.GetFileInfo(Buf: PAnsiChar; Len: LONG_PTR; FileName: PAnsiChar;
  Flag: DWord;  var FileInfo: TFileInfo): Integer;
begin
  CheckAPI(FGetFileInfo, SGetFileInfo);

  Result := FGetFileInfo(Buf, Len, FileName, Flag, FileInfo);
end;


function  TAmSPI.GetFile(Src: PAnsiChar; Len: LONG_PTR; Dest: PAnsiChar; Flag: DWord;
  ProgressCallback: TProgressCallback; Data: LONG_PTR): Integer;
begin
  CheckAPI(FGetFile, SGetFile);

  Result := FGetFile(Src, Len, Dest, Flag, ProgressCallback, Data);
end;


function  TAmSPI.GetArchiveInfoW(Buf: PWideChar; Len: LONG_PTR; Flag: DWord;
  var FileInfoHandle: THandle): Integer;
begin
  CheckAPI(FGetArchiveInfoW, SGetArchiveInfoW);

  Result := FGetArchiveInfoW(Buf, Len, Flag, FileInfoHandle);
end;


function  TAmSPI.GetFileInfoW(Buf: PWideChar; Len: LONG_PTR; FileName: PWideChar;
  Flag: DWord;  var FileInfoW: TFileInfoW): Integer;
begin
  CheckAPI(FGetFileInfoW, SGetFileInfoW);

  Result := FGetFileInfoW(Buf, Len, FileName, Flag, FileInfoW);
end;


function  TAmSPI.GetFileW(Src: PWideChar; Len: LONG_PTR; Dest: PWideChar; Flag: DWord;
  ProgressCallback: TProgressCallback; Data: LONG_PTR): Integer;
begin
  CheckAPI(FGetFileW, SGetFileW);

  Result := FGetFileW(Src, Len, Dest, Flag, ProgressCallback, Data);
end;


{------TSPIs------}
constructor TSPIs.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  if not (csDesigning in ComponentState) then begin
    if (FSusiePlugins <> nil) then begin
      raise ESPIDupCreateSPIs.Create(SDupCreateSPIs);
    end;
    FSusiePlugins := Self;
  end;

  FSearchOptions := [spsSusieDir, spsAppDir];
  FAutoSearch := True;
  FMacBinary := True;

  FEnabledUnicodeAPI := false;

  FPlugins := TList.Create;
end;

destructor TSPIs.Destroy;
begin
  if FSusiePlugins = Self then begin
    FSusiePlugins := nil;
  end;

  Clear;

  FPlugins.Free;

  inherited Destroy;
end;

procedure TSPIs.Loaded;
begin
  inherited Loaded;

  if not(csDesigning in ComponentState) and FAutoSearch then begin
{$IFDEF WIN64}
    Search('*.sph');
{$ELSE}
    Search('*.spi');
{$ENDIF}
  end;
end;


function  TSPIs.GetPlugins(Idx: Integer): TSPI;
begin
  Result := TSPI(FPlugins[Idx]);
end;


procedure TSPIs.Add(ASPI: TSPI);
begin
  Insert(Count, ASPI);
end;


procedure TSPIs.Insert(Idx: Integer; ASPI: TSPI);
var
  graphicClass: TGraphicClass;
  exts: String;
  ext: String;
  fileType: String;
  spiIdx: Integer;
  dlmIdx: Integer;
  dotIdx: Integer;
  dlmPos: PChar;
begin
  FPlugins.Insert(Idx, ASPI);
  if not(csDesigning in ComponentState) and
    (ASPI is TInSPI)  then begin
    for spiIdx := 0 to ASPI.ExtNames.Count-1 do begin
      // ANSIもUnicodeも同じ物を返却する前提で、ANSI版のみを扱う
      graphicClass := FDefaultGraphic;
      exts := ASPI.ExtNames[spiIdx];
      fileType := ASPI.FileTypes[spiIdx];
      while exts <> '' do begin
        dlmPos := StrRScan(PChar(exts), ';');
        if dlmPos <> nil then begin
          dlmIdx := (dlmPos-PChar(exts))+1;
          ext := Copy(exts, dlmIdx+1, MaxInt);
          exts := Copy(exts, 1, dlmIdx-1);
        end
        else begin
          ext := exts;
          exts := '';
        end;
        dotIdx := Pos('.', ext);
        if 0 < dotIdx then begin
          ext := Copy(ext, dotIdx+1, MaxInt);
        end;
        if Assigned(FOnPictureRegister) then begin
          FOnPictureRegister(Self, TInSPI(ASPI), ext, fileType, graphicClass);
        end;
        if graphicClass <> nil then begin
          TPicture.RegisterFileFormat( ext, fileType, graphicClass);
        end;
      end;
    end;
  end;
end;


procedure TSPIs.Delete(Idx: Integer);
begin
  TSPI(FPlugins[Idx]).Free;
  FPlugins.Delete(Idx);
end;


procedure TSPIs.Remove(ASPI: TSPI);
var
  idx: Integer;
begin
  idx := IndexOf(ASPI);
  if idx >= 0 then begin
    Delete(idx);
  end;
end;


function  TSPIs.IndexOf(ASPI: TSPI): Integer;
begin
  Result := FPlugins.IndexOf(ASPI);
end;


function  TSPIs.IndexOfSPIName(ASPIName: String): Integer;
var
  idx: Integer;
begin
  Result := -1;
  for idx := 0 to Count-1 do begin
    // NTFS上ではａとＡは同じ文字扱い
    if AnsiCompareText(Plugins[idx].FileName, ASPIName) = 0 then begin
      Result := idx;
      Exit;
    end;
  end;
end;


procedure TSPIs.Exchange(Idx1, Idx2: Integer);
begin
  FPlugins.Exchange(Idx1, Idx2);
end;

procedure TSPIs.Clear;
begin
  while(Count > 0) do begin
    Delete(0);
  end;
end;

function  TSPIs.Count: Integer;
begin
  Result := FPlugins.Count;
end;


procedure TSPIs.FindPluginList(
  AClasses: array of TSPIClass;
  APriorityExt: String;
  AList: TList);
var
  spi: TSPI;
  idx: Integer;
  ext: String;

  function  IsInClasses(ASPI: TSPI): Boolean;
  var
    idx: Integer;
  begin
    Result := False;
    for idx := Low(AClasses) to High(AClasses) do begin
      if ASPI is AClasses[idx] then begin
        Result := True;
        Exit;
      end;
    end;
  end;

  function  HasPriorityExt(ASPI: TSPI): Boolean;
  var
    idx: Integer;
  begin
    Result := False;
    if ext <> '' then begin
      // ANSIもUnicodeも同じ物を返却する前提で、ANSI版のみを扱う
      for idx := 0 to ASPI.ExtNames.Count-1 do begin
        if AnsiCompareText(ExtractFileExt(ASPI.ExtNames[idx]), ext) = 0 then begin
          Result := True;
          Exit;
        end;
      end;
    end;
  end;

begin
  ext := ExtractFileExt(APriorityExt);
  for idx := 0 to FPlugins.Count-1 do begin
    spi := TSPI(FPlugins[idx]);
    if IsInClasses(spi) then begin
      if HasPriorityExt(spi) then begin
        AList.Insert(0, spi);
      end
      else begin
        AList.Add(spi);
      end;
    end;
  end;
end;


procedure TSPIs.Search(AWildCard: TFileName);
var
  reg: TRegistry;
  dir: String;
  dirBuf: array[0..255] of Char;

  function AddSeparator(Path: String): String;
  begin
    if (Path <> '') and (Path[Length(Path)] <> '\') then begin
      Result := Path+'\';
    end
    else begin
      Result := Path;
    end;
  end;

{$WARN SYMBOL_PLATFORM OFF}
  procedure LoadPlugins(dir:String; path: String);
  const
    searchAttr = faReadOnly + faSysFile + faArchive;
  var
    fileNames: TStringList;
    rec: TSearchRec;
    found: Boolean;
    idx: Integer;
    spi: TSPI;
    accept: Boolean;
  begin
    found := FindFirst(dir+path, searchAttr, rec) = 0;
    try
      if found then begin
        fileNames := TStringList.Create;
        try
          while found do begin
            if IndexOfSPIName(dir+rec.Name) < 0 then begin
              fileNames.Add(dir+rec.Name);
            end;
            found := FindNext(rec) = 0;
          end;
          for idx := 0 to fileNames.Count-1 do begin
            accept := True;

            if Assigned(FOnSearching) then begin
              FOnSearching(Self, fileNames[idx], accept);
            end;
            if not accept then begin
              Continue;
            end;

            spi := CreateSPI(fileNames[idx],EnabledUnicodeAPI);
            if (spi <> nil) then begin
              try
                accept := True;
                if Assigned(FOnSearch) then begin
                  FOnSearch(Self, spi, accept);
                end;
                if accept then begin
                  Add(spi);
                end
                else begin
                  spi.Free;
                  spi := nil;
                end;
              except
                spi.Free;
              end;
            end;
          end;
        finally
          fileNames.Free;
        end;
      end;
    finally
      FindClose(rec);
    end;
  end;
{$WARN SYMBOL_PLATFORM ON}

begin
  dir := ExtractFilePath(AWildCard);
  if dir <> '' then begin
    LoadPlugins(AddSeparator(dir), ExtractFileName(AWildCard));
  end
  else begin
    if spsSusieDir in FSearchOptions then begin
      // 最初にHKEY_CURRENT_USER\Software\Takechin\Susie2\PluginのFolderをチェック
      reg := TRegistry.Create(KEY_READ);
      try
        reg.RootKey:=HKEY_CURRENT_USER;
        if reg.OpenKey(SSPIRegKey2, false) then begin
          try
            dir := reg.ReadString(SSPIRegPath2);
            if dir <> '' then begin
              LoadPlugins(AddSeparator(dir), AWildCard);
            end;
          except
            on ERegistryException do begin
            end;
          end;
        end;
      finally
        reg.free;
      end;
      // 次に従来の処理
      reg := TRegistry.Create;
      try
        if reg.OpenKey(SSPIRegKey, False) then begin
          try
            dir := reg.ReadString('Path');
            if dir <> '' then begin
              LoadPlugins(AddSeparator(dir), AWildCard);
            end;
          except
            on ERegistryException do begin
            end;
          end;
        end;
      finally
        reg.Free;
      end;
    end;
    if spsAppDir in FSearchOptions then begin
      dir := ExtractFileDir(ParamStr(0));
      LoadPlugins(AddSeparator(dir), AWildCard);
    end;
    if spsCurrentDir in FSearchOptions then begin
      dir := GetCurrentDir;
      LoadPlugins(AddSeparator(dir), AWildCard);
    end;
    if spsSystemDir in FSearchOptions then begin
      if GetSystemDirectory(dirBuf, SizeOf(dirBuf)-1) > 0 then begin
        dir := dirBuf;
        LoadPlugins(AddSeparator(dir), AWildCard);
      end;
    end;
    if spsWindowsDir in FSearchOptions then begin
      if GetWindowsDirectory(dirBuf, SizeOf(dirBuf)-1) > 0 then begin
        dir := dirBuf;
        LoadPlugins(AddSeparator(dir), AWildCard);
      end;
    end;
  end;
end;


class procedure TSPIs.SetDefaultGraphic(Value: TGraphicClass);
begin
  FDefaultGraphic := Value;
end;


class function  TSPIs.GetDefaultGraphic: TGraphicClass;
begin
  Result := FDefaultGraphic;
end;

{ TMethodTypeData }

{
constructor TMethodTypeData.Create(const ATypeData: TTypeData);
var
  pParamList: PAnsiChar; // Delphi2009でもPAnsiChar
  paramCnt: Integer;
  idx: Integer;
  newParam: TMethodParam;
  paramLength: Integer;
begin
  inherited Create;

  FKind := ATypeData.MethodKind;

  FParams := TList.Create;

  pParamList := @(ATypeData.ParamList);

  paramCnt := ATypeData.ParamCount;

  for idx := 0 to paramCnt-1 do begin
    newParam := TMethodParam.Create;
    try
      with newParam do begin
        FFlags := TParamFlags(pParamList^);
        Inc(pParamList);
        FName := string(PShortString(pParamList)^);
        paramLength := Byte(pParamList^);
        Inc(pParamList, paramLength+1);
        FTypeName := string(PShortString(pParamList)^);
        paramLength := Byte(pParamList^);
        Inc(pParamList, paramLength+1);
      end;

      if FKind = mkFunction then begin
        FReturnTypeName := String(PShortString(pParamList)^);
      end;

      FParams.Add(newParam);
    except
      newParam.Free;
      raise;
    end;
  end;

end;

destructor TMethodTypeData.Destroy;
begin
  FParams.Free;

  inherited Destroy;
end;

function TMethodTypeData.GetParamCount: Integer;
begin
  Result := FParams.Count;
end;

function TMethodTypeData.GetParams(Idx: Integer): TMethodParam;
begin
  Result := TMethodParam(FParams[Idx])
end;


procedure GraphicLoadFromStreamWithName(AGraphic: TGraphic; Stream: TStream;
  FileName: String);
var
  pProp: PPropInfo;
  pType: PTypeInfo;
  method: TMethod;
begin
  pProp := GetPropInfo(AGraphic.ClassInfo, 'OnLoadFromStreamWithName');
  if pProp <> nil then begin
    pType := pProp^.PropType^;
    if pType^.Kind = tkMethod then begin
      with TMethodTypeData.Create(GetTypeData(pType)^) do begin
        try
          if (Kind = mkProcedure) and
             (Params[0].Flags = [pfAddress]) and
             (Params[0].TypeName = 'TStream') and
             (Params[1].Flags = [pfConst]) and (Params[1].TypeName = 'String')
            then begin
            method := GetMethodProp(AGraphic, pProp);
            TSPILoadFromStreamWithNameEvent(method)(Stream, FileName);
            Exit;
          end;
        finally
          Free;
        end;
      end;

    end;
  end;

  AGraphic.LoadFromStream(Stream);
end;
}

procedure Register;
begin
  RegisterComponents('OldSamples', [TSPIs]);
end;

end.
