﻿unit testf;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ExtDlgs,
  SPIs, Vcl.CheckLst, Vcl.ComCtrls, System.Generics.Collections;

type
  TTestForm = class(TForm)
    Panel1: TPanel;
    ScrBox: TScrollBox;
    Img: TImage;
    OpenPicDlg: TOpenPictureDialog;
    StsBar: TStatusBar;
    SearchGBox: TGroupBox;
    SearchBtn: TButton;
    UseUnicodeCBox: TCheckBox;
    CheckLBox: TCheckListBox;
    PicGBox: TGroupBox;
    PicOpenButton: TButton;
    BmpTypeRG: TRadioGroup;
    FsCBox: TCheckBox;
    ArcGBox: TGroupBox;
    ArcOpenBtn: TButton;
    OpenArcDlg: TOpenDialog;
    ArcLBox: TListBox;
    ShowBtn: TButton;
    FSPIs: TSPIs;
    SPILBox: TListBox;
    ArcFileLB: TLabel;
    ArcBMpRGrp: TRadioGroup;
    procedure PicOpenButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SearchBtnClick(Sender: TObject);
    procedure UseUnicodeCBoxClick(Sender: TObject);
    procedure CheckLBoxClickCheck(Sender: TObject);
    procedure BmpTypeRGClick(Sender: TObject);
    procedure ArcOpenBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ShowBtnClick(Sender: TObject);
  private
    { Private 宣言 }
    FTrgArcFile : string;
    FArcSPI : TAmSPI;
    FList : TList<ULONG_PTR>;
  public
    { Public 宣言 }
  end;

var
  TestForm: TTestForm;

implementation

{$R *.dfm}

uses
  SPIBmp,SPINkDIB;

const
{$IFDEF WIN64}
  captionstr='SPIs test x64';
  PLUGIN_EXT = 'sph';
{$ELSE}
  captionstr='SPIs test x86';
  PLUGIN_EXT = 'spi';
{$ENDIF}

procedure TTestForm.ArcOpenBtnClick(Sender: TObject);
var
  i,j : integer;
  ext,filter,all : string;
  spi : TAmSPI;
  AnsiName : AnsiString;
  //
  // 読み込めるTAmSPIならばtrueを返す
  //
  function checkSupported(spi:TAmSPI):boolean;
  const
    BUFSIZE = 2000+MacBinaryOffset;
  var
    data : array[0..BUFSIZE-1] of byte;
    fs : TFileStream;
  begin
    fs:=TFIleStream.Create(OpenArcDlg.FileName,fmOpenRead);
    try
      fs.Read(data,BUFSIZE);
    finally
      fs.Free;
    end;
    if spi.EnabledUnicodeAPI then begin
      result:=spi.IsSupportedW(PWideChar(OpenARcDlg.Filename),@data[0])<>0;
      if (not result) and FSPIs.MacBinary then
        result:=spi.IsSupportedW(PWideChar(OpenARcDlg.Filename),@data[MacBinaryOffset])<>0;
    end else begin
      AnsiName:=AnsiString(OpenArcDLg.FileName);
      result:=spi.IsSupported(PAnsiChar(ansiname),@data[0])<>0;
      if (not result) and FSPIs.MacBinary then
        result:=spi.IsSupported(PAnsiChar(Ansiname),@data[MacBinaryOffset])<>0;
    end;
  end;
  //
  // archive file内のファイル名をListboxに格納する
  //
  procedure GetFileListFromArcFile(spi:TAmSPI);
  var
    p:HLOCAL;
    pfi:PFileInfo;
    pfiw:PFIleInfoW;
    sts : integer;
    trgname : string;
    AnsiName : AnsiString;
  begin
    AnsiName:=AnsiString(OpenArcDlg.FileName);
    if spi.EnabledUnicodeAPI then
      sts:=spi.GetArchiveInfoW(PWideChar(OpenARcDLg.FileName),0,0,p)
    else
      sts:=spi.GetArchiveInfo(PAnsiChar(AnsiName),0,0,p);
    if (sts<>0) and FSPIs.MacBinary then begin
      if spi.EnabledUnicodeAPI then
        sts:=spi.GetArchiveInfoW(PWideChar(OpenARcDLg.FileName),MacBinaryOffset,0,p)
      else
        sts:=spi.GetArchiveInfo(PAnsiChar(AnsiName),MacBinaryOffset,0,p);
    end;
    if sts<>0 then Exit;
    //
    try
      if spi.EnabledUnicodeAPI then begin
        pfiw:=PFileInfoW(Pointer(p)^);
        while pfiw^.Method[0]<>#0 do begin
          trgname:=string(pfiw^.path)+string(pfiw^.FileName);
          ArcLBox.AddItem(trgname,nil);
          FList.Add(pfiw^.Position);
          inc(pfiw);
        end;
      end else begin
        pfi:=PFileInfo(Pointer(p)^);
        while pfi^.Method[0]<>#0 do begin
          trgname:=string(pfi^.path)+string(pfi^.FileName);
          ArcLBox.AddItem(trgname,nil);
          FList.Add(pfi^.Position);
          inc(pfi);
        end;
      end;
    finally
      LocalFree(p);
    end;
  end;
begin
  filter:=''; all:='';
  for i := 0 to FSPIs.Count - 1 do begin
    if NOT (FSpis.Plugins[i] is TAmSPI) then continue;
    for j:=0 to FSPIs.Plugins[i].ExtNames.Count-1 do begin
      ext:=FSPIs.Plugins[i].ExtNames[j];
      if filter='' then begin
        filter:=copy(ext,3,length(ext)-2)+' files|'+ext;
        all:='all files|'+ext;
      end else begin
        filter:=filter+'|'+copy(ext,3,length(ext)-2)+' files|'+ext;
        all:=all+';'+ext;
      end;
    end;
  end;
  OpenArcDlg.Filter:=all+'|'+filter;
  if OpenArcDlg.Execute(handle) then begin
    ArcLBox.Clear;
    FList.Clear;
    FTrgArcFIle:='';
    ArcFileLB.Caption:='n/a';
    ShowBtn.Enabled:=false;
    FArcSPI:=nil;
    Img.Picture.Assign(nil);
    // 対応するTAmSPI取得
    spi:=nil;
    for i:=0 to FSPIs.Count-1 do begin
      if not (FSPIs.Plugins[i] is TAmSPI) then continue;
      if checkSupported(FSPIs.Plugins[i] as TAmSPI) then begin
        spi:=FSPIs.Plugins[i] as TAmSPI;
        break;
      end;
    end;
    if spi=nil then exit;
    FArcSPI:=spi;
    // リスト取得
    GetFileListFromArcFile(spi);
    //
    FTrgArcFile:=OpenArcDlg.FileName;
    ArcFileLB.Caption:=ExtractFilename(FTrgArcFile);
    ShowBtn.Enabled:=ArcLBox.Count>0;
  end;
end;

procedure TTestForm.BmpTypeRGClick(Sender: TObject);
begin
  FsCBox.Enabled:=BmpTypeRG.ItemIndex<>2; // Image以外有効
end;

procedure TTestForm.CheckLBoxClickCheck(Sender: TObject);
var
  sps : TSPISearchOptions;
  I: integer;
begin
  sps:=[];
  for I:=0 to CheckLBox.Items.Count-1 do
    if CheckLBox.Checked[i] then sps:=sps+[TSPISearchOption(i)];
  FSPIs.SearchOptions:=sps;
end;

procedure TTestForm.FormCreate(Sender: TObject);
begin
  caption:=captionstr;
  FTrgArcFile:='';
  FArcSPI:=nil;
  FList:=TList<ULONG_PTR>.Create;
  CheckLBox.Checked[0]:=true;
  CheckLBox.Checked[1]:=true;
end;

procedure TTestForm.FormDestroy(Sender: TObject);
begin
  FList.Free;
end;

procedure TTestForm.PicOpenButtonClick(Sender: TObject);
var
  i,j : integer;
  ext,filter,all : string;
  bmp : TSPIBitmap;
  dib : TSPINkDIB;
  fs : TFileStream;
begin
  filter:= ''; all:='';
  for i := 0 to FSPIs.Count - 1 do begin
    if NOT (FSpis.Plugins[i] is TInSPI) then continue;
    for j:=0 to FSPIs.Plugins[i].ExtNames.Count-1 do begin
      ext:=FSPIs.Plugins[i].ExtNames[j];
      if filter='' then begin
        filter:=copy(ext,3,length(ext)-2)+' files|'+ext;
        all:='all files|'+ext;
      end else begin
        filter:=filter+'|'+copy(ext,3,length(ext)-2)+' files|'+ext;
        all:=all+';'+ext;
      end;
    end;
  end;
  OpenPicDlg.Filter:=all+'|'+filter;
  if OpenPicDlg.Execute(handle) then begin
    Img.Picture.Assign(nil);
    if BmpTypeRG.ItemIndex=1 then begin
      // TSPINkDIBのテスト
      dib:=TSPINkDIB.Create;
      try
        if FsCBox.Checked then begin
          fs:=TFileStream.Create(OpenPicDlg.FileName,fmOpenRead);
          try
            // SPI/SPHによっては拡張子で判断する場合があるため
            // LoadFromStreamWithNameの方で読み込む方が良い
            dib.LoadFromStreamWithName(fs,OpenPicDlg.FileName);
          finally
            fs.free;
          end;
        end else
          dib.LoadFromFile(OpenPicDlg.Filename);
        Img.Width:=dib.Width; Img.Height:=dib.Height;
        Img.Picture.assign(dib);
      finally
        dib.free;
      end;
    end else if BmpTypeRG.ItemIndex=0 then begin
      // TSPIBitmapのテスト
      bmp:=TSPIBitmap.Create;
      try
        if FsCBox.Checked then begin
          fs:=TFileStream.Create(OpenPicDlg.FileName,fmOpenRead);
          try
            // SPI/SPHによっては拡張子で判断する場合があるため
            // LoadFromStreamWithNameの方で読み込む方が良い
            bmp.LoadFromStreamWithName(fs,OpenPicDlg.FileName);
          finally
            fs.free;
          end;
        end else
          bmp.LoadFromFile(OpenPicDlg.Filename);
        Img.Picture.Assign(nil);
        Img.Width:=bmp.Width; Img.Height:=bmp.Height;
        Img.Picture.assign(bmp);
      finally
        bmp.free;
      end;
    end else begin
      img.picture.LoadFromFile(OpenPicDlg.Filename);
      img.Width:=img.Picture.Width;
      img.height:=img.Picture.Height;
    end;
    caption:=captionstr+' - '+ExtractFilename(OpenPicDlg.FileName);
  end;
end;

procedure TTestForm.SearchBtnClick(Sender: TObject);
var
  InCount,AmCount,i : integer;
  nm : string;
  spi : TSPI;
begin
  FSPIs.Clear;
  FSPIs.Search('*.'+PLUGIN_EXT);
  //
  SPILBox.Clear;
  ArcLBox.Clear; FList.Clear; FTrgArcFile:=''; FArcSPI:=nil;
  InCount:=0; AmCount:=0;
  for i := 0 to FSPIs.Count-1 do begin
    spi:=FSPIs.Plugins[i];
    if spi is TInSPI then begin
      inc(InCount);
      nm:='I';
    end else if spi is TAmSPI then begin
      inc(AmCount);
      nm:='A';
    end;
    if spi.EnabledUnicodeAPI then
      nm:=nm+'U '
    else
      nm:=nm+'A ';
    SPILBox.AddItem(nm+ExtractFilename(spi.FileName),spi);
  end;
  PicGBox.Enabled:=InCount>0;
  PicGBox.Visible:=PicGBox.Enabled;
  ArcGBox.Enabled:=Amcount>0;
  ArcGBox.Visible:=ArcGBox.Enabled;
  ShowBtn.Enabled:=false;
end;

procedure TTestForm.ShowBtnClick(Sender: TObject);
var
  hm : HLOCAL;
  ofs : LONG_PTR;
  idx : integer;
  fname : string;
  aarcname,
  aname : AnsiString;
  sts : integer;
  pB  : PByte;
  ms : TMemoryStream;
  bmp : TSPIBitmap;
  nkbmp : TSPINkDIB;
begin
  if ArcLBox.ItemIndex<0 then exit;
  //
  Img.Picture.Assign(nil);
  idx:=ArcLBox.ItemIndex;
  aarcname:=ANsiString(FTrgArcFile);
  fname:=ArcLBox.Items[idx]; aname:=AnsiString(fname);
  ofs:=FList.Items[idx];
  // カレントのファイルをメモリに格納
  if FArcSPI.EnabledUnicodeAPI then
    sts:=FArcSPI.GetFileW(PWideChar(FTrgArcFile),ofs,@hm,$100,nil,0)
  else
    sts:=FArcSPI.GetFile(PAnsiChar(aarcname),ofs,@hm,$100,nil,0);
  if (sts<>0) then  begin
    ShowMessage('cannot open '+fname+' err='+IntToStr(sts));
    exit;
  end;
  try
    // メモリから読み込んで画像へ
    pB:=PByte(LocalLock(hm));
    if pB=nil then begin
      ShowMessage('cannot lock local memory');
    end else begin
      try
        sts:=LocalSize(hm);
        if sts<=0 then begin
          ShowMessage('memory size error ('+IntToStr(sts)+')');
        end else begin
          ms:=TMemoryStream.Create;
          try
            ms.SetSize(sts);
            ms.Position:=0;
            ms.WriteBuffer(pB^,sts);
            ms.Position:=0;
            // Imageに表示
            if ArcBMpRGrp.ItemIndex=0 then begin
              bmp:=TSPIBitmap.Create;
              try
                bmp.LoadFromStreamWithName(ms,fname);
                Img.Width:=bmp.Width; Img.Height:=bmp.Height;
                Img.Picture.assign(bmp);
              finally
                bmp.Free;
              end;
            end else begin
              nkbmp:=TSPINkDIB.Create;
              try
                nkbmp.LoadFromStreamWithName(ms,fname);
                Img.Width:=nkbmp.Width; Img.Height:=nkbmp.Height;
                Img.Picture.assign(nkbmp);
              finally
                nkbmp.Free;
              end;
            end;
          finally
            ms.Free;
          end;
        end;
      finally
        LocalUnlock(hm);
      end;
    end;
  finally
    LocalFree(hm);
  end;
end;

procedure TTestForm.UseUnicodeCBoxClick(Sender: TObject);
begin
  FSPIs.EnabledUnicodeAPI:=UseUnicodeCBox.Checked;
end;

end.
